class input_gzip_rec gzip_ch : Netchannels.rec_in_channel =
object(self)
  val mutable closed = false

  method input s p l = 
    let n = Gzip.input gzip_ch s p l in
    if n = 0 then raise End_of_file;
    n
  method close_in() =
    if not closed then (
      Gzip.close_in gzip_ch;
      closed <- true
    )
end


class input_gzip gzip_ch =
  Netchannels.lift_rec_in_channel (new input_gzip_rec gzip_ch)


class output_gzip_rec gzip_ch : Netchannels.rec_out_channel =
object(self)
  method output s p l =
    Gzip.output gzip_ch s p l;
    l
  method close_out() =
    (* FIXME: No way to suppress errors... *)
    Gzip.close_out gzip_ch
  method flush() =
    ()
    (* Gzip.flush gzip_ch *)  (* does not work, bug in camlzip *)
end


class output_gzip gzip_ch =
  Netchannels.lift_rec_out_channel (new output_gzip_rec gzip_ch)

    
let () =
  Pax.read_gzip :=
    (function 
       | None ->
           new input_gzip (Gzip.open_in_chan stdin)
       | Some file ->
           new input_gzip (Gzip.open_in_chan (open_in_bin file))
    )


let () =
  Pax.write_gzip :=
    (function 
       | None ->
           new output_gzip (Gzip.open_out_chan stdout)
       | Some file ->
           new output_gzip (Gzip.open_out_chan (open_out_bin file))
    )
      
